'use strict';

const Promise  = require('bluebird');
const eventbus = require('../index');


const main = async () => {
    await exportDocs();
};


const tranformDoc = async (row) => {
    return row;
};

const loadDoc = async (data) => {
    return;
};

const exportDocs = async () => {

    const cursor = await eventbus.getAllEventsByName('myevent');

    const totalCount = await cursor.count();
    console.log(`Total count: ${totalCount}`);
    let count        = 0;

    let row = await cursor.next();
    while (row) {
        const data = await tranformDoc(row);
        await loadDoc(data);
        count++;
        console.log(`handled ${count} out of: ${totalCount}. ${JSON.stringify(data)}`);
        row = await cursor.next();
    }

    await cursor.close();
};

Promise.resolve()
    .then(async () => {
        eventbus.init({
            bus: {
                url: 'amqp://codefresh.dev', // rabbitmq server
                reconnectInterval: 5
            },
            store: {
                host: 'codefresh.dev', // postgres host
                database: 'postgres', // postgres database
                user: 'postgres', // postgres user
                password: 'postgres' // postgres password
            },
            microServiceName: 'service-name' // client name
        });

        eventbus.on('ready', async () => {
            try {
                await main();
                await eventbus.quit();
            } catch (err) {
                console.error(err.stack);
            }
        });
    });