﻿"use strict";

const tables = `CREATE SCHEMA IF NOT EXISTS eventstore;
CREATE TABLE IF NOT EXISTS eventstore.events
(
    id serial NOT NULL,
    event text NOT NULL,
    aggregate_id text,
    account_id text,
    user_id text,
    props jsonb NOT NULL,
    timestamp timestamp NOT NULL,
    publisher text NOT NULL,
    CONSTRAINT "events.id" PRIMARY KEY (id)
);
CREATE INDEX IF NOT EXISTS event_name
    ON eventstore.events USING btree
    (event ASC NULLS LAST);
CREATE INDEX IF NOT EXISTS aggregate_id
    ON eventstore.events USING btree
    (aggregate_id ASC NULLS LAST);`;

module.exports = tables;